#!/bin/python3
import os, sys, subprocess, time

def main() :
    # copy (std.in) to "original.txt"
    with open("original.txt", mode='w') as f:
        try:
            while True:
                line=input()
                f.write(line + "\n")
        except EOFError:
            pass

    numProc = 3
    files = ["sc.txt", "xcc.txt", "tdzdd.txt"]
    try:
        for file in files:
            if not os.path.isfile(file) :continue
            os.remove(file)
            
        # run all programs (in parallel)
        processes = [subprocess.Popen("exec timeout 600 ./SimpleCount/a.out < original.txt > sc.txt", shell=True),
                     subprocess.Popen("exec timeout 600 ./xcc/a.out < original.txt > xcc.txt", shell=True),
                     subprocess.Popen("exec timeout 600 ./tdzdd.sh < original.txt > tdzdd.txt", shell=True)]

        # wait for process
        finishCount = 0
        ansId = -1
        finished = [False] * numProc
        while True:
            for i in range(numProc):
                if finished[i] or processes[i].poll() is None: continue
                # process i finished
                finished[i] = True
                finishCount += 1
                if os.path.isfile(files[i]) and os.path.getsize(files[i]) > 0 :
                    # process finished with answer
                    ansId = i
                    break
                if finishCount == numProc :
                    # all processes finished w/o answer
                    break
            else :
                time.sleep(0.1)
                continue
            break

        # output answer
        if ansId >= 0:
            with open(files[ansId]) as f:
                print(f.read(), end="")
        else :
            print("No answer",file=sys.stderr)

    finally :
        # terminate all processes
        if "processes" in locals() :
            for p in processes :
                try:
                    p.terminate()
                except ProcessLookupError:
                    pass

if __name__ == '__main__':
    main()
